using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Previsiones._1_Modelos;
using static Exferia_Aplicacion.General.Enumerados;
using System.Transactions;
using System.Data.SqlClient;
using System.Threading;
using System.Reflection;

namespace Exferia_Previsiones._2_Datos
{
    public class PRE_PrevisionesAuxiliares_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo> g_lst_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_PRE= null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(PRE_PrevisionesAuxiliares).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo != null) && (g_lst_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Count() > 0))
                {
                    lst_PRE = g_lst_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_PRE;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_PRE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(PRE_PrevisionesAuxiliares).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo != null) && (g_lst_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Count() > 0))
                {
                    dnm_PRE = g_lst_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_PRE;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                  " SELECT " +
                      nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.id) + " = " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.id) + "," +
                      nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.importe) + " = " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.importe) + "," +
                      nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.tipo) + " = " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.tipo) + "," +
                      nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.fecha) + " = " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.fecha) + "," +
                      nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.estado) + " = " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.estado) + "," +
                      //ids
                      nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.idTesoreria) + " = " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.idTesoreria) + "," +
                      //Tesoreria
                      (
                           (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Tesoreria)))
                               ?
                                   (
                                       nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Tesoreria_Codigo) + " = " + nameof(MAE_Tesorerias) + "." + nameof(MAE_Tesorerias.codigo) + "," +
                                       nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Tesoreria_Descripcion) + " = " + nameof(MAE_Tesorerias) + "." + nameof(MAE_Tesorerias.descripcion) + "," +
                                       nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Tesoreria_FechaBorrado) + " = " + nameof(MAE_Tesorerias) + "." + nameof(MAE_Tesorerias.fechaBorrado)
                                   )
                               :
                                   (
                                       nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Tesoreria_Codigo) + " = ''," +
                                       nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Tesoreria_Descripcion) + " = ''," +
                                       nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Tesoreria_FechaBorrado) + " = NULL "
                                   )
                      ) +
                      " FROM " + nameof(PRE_PrevisionesAuxiliares) +
                      //Tesoreria
                      (
                          (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.Tesoreria)))
                          ?
                              (
                                      " LEFT JOIN " + nameof(MAE_Tesorerias) + " ON " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.idTesoreria) + " = " + nameof(MAE_Tesorerias) + "." + nameof(MAE_Tesorerias.id)
                              )
                          : ("")
                      ) +
                      " WHERE " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.fechaBorrado) + " IS null AND " +
                                  (_lng_id > -1 ? nameof(PRE_PrevisionesAuxiliares) + "." + (nameof(PRE_PrevisionesAuxiliares.id) + "=@id") : "1 = 1");

                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@id", _lng_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo g_mdl_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_PRE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(PRE_PrevisionesAuxiliares).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo_F3 != null)
                {
                    dnm_PRE = g_mdl_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_PRE;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_PRE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Conuslta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(PRE_PrevisionesAuxiliares).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo_F3 != null)
                {
                    dnm_PRE = g_mdl_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_PRE;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

            try
            {
                string str_SQL =
                  " SELECT distinct " +
                      nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.id) + " = " + nameof(PRE_PrevisionesAuxiliares.id) + "," +
                      nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.fecha) + " = " + nameof(PRE_PrevisionesAuxiliares.fecha) + "," +
                      nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.importe) + " = " + nameof(PRE_PrevisionesAuxiliares.importe) +
                  " FROM " + nameof(PRE_PrevisionesAuxiliares) +
                  " WHERE " + nameof(PRE_PrevisionesAuxiliares.fechaBorrado) + " IS null AND " +
                            (
                               (_lng_id > -1)
                                 ? (nameof(PRE_PrevisionesAuxiliares.id) + " = " + _lng_id)
                                 : (
                                      //Filtrar por importe
                                      (_str_CampoBusqueda.Equals(nameof(PRE_PrevisionesAuxiliares.importe)))
                                          ? (nameof(PRE_PrevisionesAuxiliares.importe) + "=convert(decimal(18,4),@Filtro)")
                                          //Filtrar por Fecha
                                          : (nameof(PRE_PrevisionesAuxiliares.fecha) + "=convert(datetime,@Filtro)")
                                   )
                              );

                //Parametrso
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@Filtro", _str_Filtro)
                };

                //Rellenar el Modelo
                g_mdl_INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 1;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                        " SELECT " +
                            nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.id) + "=" + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.id) + "," +
                            nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.importe) + "=" + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.importe) + "," +
                            nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.tipo) + "=" + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.tipo) + "," +
                            nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.fecha) + "=" + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.fecha) + "," +
                            nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.estado) + "=" + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.estado) + "," +
                            nameof(INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo.idTesoreria) + "=" + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.idTesoreria) +
                        " FROM " + nameof(PRE_PrevisionesAuxiliares) +
                        " WHERE  " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.fechaBorrado) + " IS null AND " +
                                    nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_PRE_PrevisionesAuxiliares_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MAE_Tesorerias ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idTesoreria != null)
                    {
                        ThreadStart obj_ThreadStart_TESORERIAS = new ThreadStart(Obtener_Tesorerias_Modelo_Obtener);
                        Thread obj_Thread_TESORERIAS = new Thread(obj_ThreadStart_TESORERIAS);
                        obj_Thread_TESORERIAS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Tesorerias_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAETESORERIAS_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idTesoreria};
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Tesorerias = (MAE_Tesorerias)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        
        public string Obtener_Estado(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            string str_Estado = "";

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                        " SELECT " +
                            nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.estado) +
                        " FROM " + nameof(PRE_PrevisionesAuxiliares) +
                        " WHERE  " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.fechaBorrado) + " IS null AND " +
                                    nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                str_Estado = obj_Exferia_Entities.Database.SqlQuery<string>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(Obtener_Estado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return str_Estado;
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private PRE_PrevisionesAuxiliares g_mdl_PRE_PrevisionesAuxiliares = null;

        public PRE_PrevisionesAuxiliares Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_PRE_PrevisionesAuxiliares;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_PRE_PrevisionesAuxiliares = obj_Exferia_Entities.Database.SqlQuery<PRE_PrevisionesAuxiliares>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.id) + "," +
                    nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.idTesoreria) + "," +
                    nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.importe) + "," +
                    nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.tipo) + "," +
                    nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.fecha) + "," +
                    nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.estado) + "," +
                    nameof(PRE_PrevisionesAuxiliares) + "." + nameof(PRE_PrevisionesAuxiliares.fechaBorrado) +
                " FROM " + nameof(PRE_PrevisionesAuxiliares);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                PRE_PrevisionesAuxiliares mdl_PRE_PrevisionesAuxiliares_AGrabar = (PRE_PrevisionesAuxiliares)_mdl_obj;
                PRE_PrevisionesAuxiliares mdl_PRE_PrevisionesAuxiliares_DatosViejos = new PRE_PrevisionesAuxiliares();

                // Ver si existe ######################################################################
                PRE_PrevisionesAuxiliares mdl_PRE_PrevisionesAuxiliares_Final = Obtener_Modelo_Por_Id(mdl_PRE_PrevisionesAuxiliares_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_PRE_PrevisionesAuxiliares_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_PRE_PrevisionesAuxiliares_Final, mdl_PRE_PrevisionesAuxiliares_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_PRE_PrevisionesAuxiliares_AGrabar, mdl_PRE_PrevisionesAuxiliares_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(PRE_PrevisionesAuxiliares) +
                                           " SET " +
                                               nameof(PRE_PrevisionesAuxiliares.idTesoreria) + "=@idTesoreria," +
                                               nameof(PRE_PrevisionesAuxiliares.importe) + "=@importe," +
                                               nameof(PRE_PrevisionesAuxiliares.tipo) + "=@tipo," +
                                               nameof(PRE_PrevisionesAuxiliares.fecha) + "=@fecha," +
                                               nameof(PRE_PrevisionesAuxiliares.estado) + "=@estado," +
                                               nameof(PRE_PrevisionesAuxiliares.fechaBorrado) + "=@fechaBorrado" +
                                           " WHERE " +
                                               nameof(PRE_PrevisionesAuxiliares.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                         new SqlParameter("@idTesoreria",  mdl_PRE_PrevisionesAuxiliares_Final.idTesoreria),
                         new SqlParameter("@importe",  mdl_PRE_PrevisionesAuxiliares_Final.importe),
                         new SqlParameter("@tipo",  mdl_PRE_PrevisionesAuxiliares_Final.tipo),
                         new SqlParameter("@fecha",  mdl_PRE_PrevisionesAuxiliares_Final.fecha),
                         new SqlParameter("@estado",  mdl_PRE_PrevisionesAuxiliares_Final.estado),
                         mdl_PRE_PrevisionesAuxiliares_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_PRE_PrevisionesAuxiliares_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         new SqlParameter("@id",  mdl_PRE_PrevisionesAuxiliares_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_PRE_PrevisionesAuxiliares_Final.id;

                }
                //INSERT
                else
                {
                    mdl_PRE_PrevisionesAuxiliares_Final = new PRE_PrevisionesAuxiliares();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_PRE_PrevisionesAuxiliares_AGrabar, mdl_PRE_PrevisionesAuxiliares_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(PRE_PrevisionesAuxiliares) +
                                              " (" +
                                                      nameof(PRE_PrevisionesAuxiliares.idTesoreria) + "," +
                                                      nameof(PRE_PrevisionesAuxiliares.importe) + "," +
                                                      nameof(PRE_PrevisionesAuxiliares.tipo) + "," +
                                                      nameof(PRE_PrevisionesAuxiliares.fecha) + "," +
                                                      nameof(PRE_PrevisionesAuxiliares.estado) + "," +
                                                      nameof(PRE_PrevisionesAuxiliares.fechaBorrado) +
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(PRE_PrevisionesAuxiliares.id) +
                                              " VALUES " +
                                              " ( " +
                                                  "@idTesoreria," +
                                                  "@importe," +
                                                  "@tipo," +
                                                  "@fecha," +
                                                  "@estado," +
                                                  "@fechaBorrado" +
                                              " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idTesoreria",  mdl_PRE_PrevisionesAuxiliares_Final.idTesoreria),
                        new SqlParameter("@importe",  mdl_PRE_PrevisionesAuxiliares_Final.importe),
                        new SqlParameter("@tipo",  mdl_PRE_PrevisionesAuxiliares_Final.tipo),
                        new SqlParameter("@fecha",  mdl_PRE_PrevisionesAuxiliares_Final.fecha),
                        new SqlParameter("@estado",  mdl_PRE_PrevisionesAuxiliares_Final.estado),
                        mdl_PRE_PrevisionesAuxiliares_Final.fechaBorrado != null
                           ?   new SqlParameter("@fechaBorrado", mdl_PRE_PrevisionesAuxiliares_Final.fechaBorrado.Value)
                           :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(PRE_PrevisionesAuxiliares), mdl_PRE_PrevisionesAuxiliares_DatosViejos, mdl_PRE_PrevisionesAuxiliares_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Actualizar_Estado(long _lng_id, string _str_Estado)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;
                
                PRE_PrevisionesAuxiliares mdl_PRE_PrevisionesAuxiliares_DatosViejos = new PRE_PrevisionesAuxiliares();

                // Ver si existe ######################################################################
                PRE_PrevisionesAuxiliares mdl_PRE_PrevisionesAuxiliares_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_PRE_PrevisionesAuxiliares_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_PRE_PrevisionesAuxiliares_Final, mdl_PRE_PrevisionesAuxiliares_DatosViejos, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(PRE_PrevisionesAuxiliares) +
                                           " SET " +
                                               nameof(PRE_PrevisionesAuxiliares.estado) + "=@estado" +
                                           " WHERE " +
                                               nameof(PRE_PrevisionesAuxiliares.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                         new SqlParameter("@estado",  mdl_PRE_PrevisionesAuxiliares_Final.estado),
                         new SqlParameter("@id",  mdl_PRE_PrevisionesAuxiliares_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_PRE_PrevisionesAuxiliares_Final.id;
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(PRE_PrevisionesAuxiliares), mdl_PRE_PrevisionesAuxiliares_DatosViejos, mdl_PRE_PrevisionesAuxiliares_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(Actualizar_Estado), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
            bool bol_ActualizarFechaBorrado = false;//Este campo se utiliza por si no se puede borrar, que actualice la fecha de borrado

            // Se utiliza la transaccion por la llamada al procedimiento de almacenado
            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
              try
                {
                    obj_Exferia_Entities = new Exferia_Entities();
                    obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                    // Ver si existe ######################################################################
                    PRE_PrevisionesAuxiliares mdl_PRE_PrevisionesAuxiliares_Final = Obtener_Modelo_Por_Id(_lng_id);
                    //######################################################################################

                    if (mdl_PRE_PrevisionesAuxiliares_Final != null)
                    {
                        //Se intenta borrar, si diera un error porque esta relacaionado se graba la fecha de baja
                        try
                        {
                            #region Delete
                            string str_SQL_Delete = " DELETE FROM  " + nameof(PRE_PrevisionesAuxiliares) +
                                                    " WHERE " +
                                                        nameof(PRE_PrevisionesAuxiliares.id) + "=@id";
                            //Parametros
                            object[] arr_Parametros_Delete = new object[]
                            {
                                new SqlParameter("@id", _lng_id)
                            };
                            #endregion

                            //Delete
                            obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                            // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                            Datos_Generales.USR_Trazabilidad_Grabar(typeof(PRE_PrevisionesAuxiliares), null, mdl_PRE_PrevisionesAuxiliares_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                        }
                        catch (Exception ex)
                        {
                            var sqlException = ex.GetBaseException() as SqlException;
                            if (sqlException != null)
                            {
                                if (sqlException.Errors.Count > 0)
                                {
                                    switch (sqlException.Errors[0].Number)
                                    {
                                        case Control_Errores.G_INT_ERRORCONTROLADO_BORRAR_CONFLICTO_CLAVEFORANEA: // Foreign Key violation
                                            bol_ActualizarFechaBorrado = true;
                                            break;
                                        default:
                                            throw;
                                    }
                                }
                            }
                            else
                            {
                                throw;
                            }
                        }

                        // Actualizar la fecha de baja , al no poder borrarlo por tener relaciones
                        if (bol_ActualizarFechaBorrado)
                        {
                            #region Update
                            string str_SQL_Update = " UPDATE " + nameof(PRE_PrevisionesAuxiliares) +
                                                        " SET " +
                                                        nameof(PRE_PrevisionesAuxiliares.fechaBorrado) + "=@fechaBorrado " +
                                                    " WHERE " +
                                                        nameof(PRE_PrevisionesAuxiliares.id) + "=@id";
                            //Parametros
                            object[] arr_Parametros_Update = new object[]
                            {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                            };
                            #endregion

                            //Update
                            obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                            //Grabar un registro de trazabilidad con los datos de la trasaccion realizada
                            Datos_Generales.USR_Trazabilidad_Grabar(typeof(PRE_PrevisionesAuxiliares), null, mdl_PRE_PrevisionesAuxiliares_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                        }
                    }

                    //Devolver también el Objeto
                    mdl_ValorDevuelto_Modelo.Id = mdl_PRE_PrevisionesAuxiliares_Final.id;

                    // Se termina la Transaccion Correctamente
                    transaccion_SQL.Complete();
                }
                catch (Control_Errores)
                {
                    throw;
                }
                catch (Exception ex)
                {
                    throw new Control_Errores("", ex, nameof(PRE_PrevisionesAuxiliares_Datos) + "/" + nameof(Borrar), true);
                }
                finally
                {
                    obj_Exferia_Entities.Database.Connection.Close();
                    obj_Exferia_Entities.Dispose();

                    // Finalizar transaccion
                    transaccion_SQL.Dispose();
                }
            }
            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
